.include "inc\tn13def.inc"
.equ	FCLK=9600000
.equ	TCLK=1000000000/FCLK+1
.equ	T_5us=5000/TCLK+1
.equ    T_us=1000/TCLK+1
.equ	T_ms=1000000/TCLK

.equ		DATA_OUT=	PORTB
.equ		DATA_IN=	PINB
.equ		DATA_DDR=	DDRB

.equ		REG_DATA=	DDB1
.equ		REG_CLK=	DDB0
.equ		NES_CLK=	DDB1
.equ		NES_LATCH=	DDB4
.equ		NES_DATA1=	DDB2
.equ		NES_DATA2=	DDB3


.cseg
.org	0

		rjmp	main ; Reset interrupt vector
		
.org	INT0addr	; External Interrupt 0
		reti
.org	PCI0addr	;External Interrupt Request 0 
		reti
.org	OVF0addr	;Timer/Counter0 Overflow
		reti
.org	ERDYaddr	;EEPROM Ready
		reti
.org	ACIaddr		; Analog Comparator
		reti
.org	OC0Aaddr	; 
		reti
.org	OC0Baddr	; 
		reti
        ;rjmp	Timer_OC0B 
.org	WDTaddr		; Watchdog Timer Overflow
		reti
.org	ADCCaddr
		reti	; ADC Conversion Complete
	
.org	INT_VECTORS_SIZE
.include    "inc\Delay.inc"
.include    "inc\74hc595.inc"
.include	"inc\NES_Joystick.inc"

main:
			cli
			; 
			ldi			r16,LOW(RAMEND)
			out			SPL,r16
			
			sbi		DATA_DDR, REG_DATA
			sbi		DATA_DDR, REG_CLK
			sbi		DATA_DDR, NES_LATCH
			cbi		DATA_DDR, NES_DATA1
			cbi		DATA_DDR, NES_DATA2
			

main_loop:		
			rcall	NES_POLL
			rcall	out_16bit
			nop
			nop
			nop
			rjmp	main_loop

			.org	128
DATA_XFORM: 
			;.db		$20, $40, $80, $10, $01, $04, $08, $02
			.db		$04, $02, $01, $08, $80, $20, $10, $40
